package gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.client;
import gov.nih.nci.coppa.services.pa.DocumentWorkflowStatus;
import gov.nih.nci.coppa.services.pa.Id;
import gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.common.DocumentWorkflowStatusServiceI;

import java.rmi.RemoteException;

import org.apache.axis.client.Stub;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI.MalformedURIException;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.globus.gsi.GlobusCredential;

/**
 * This class is autogenerated, DO NOT EDIT GENERATED GRID SERVICE ACCESS METHODS.
 *
 * This client is generated automatically by Introduce to provide a clean unwrapped API to the
 * service.
 *
 * On construction the class instance will contact the remote service and retrieve it's security
 * metadata description which it will use to configure the Stub specifically for each method call.
 *
 * @created by Introduce Toolkit version 1.3
 */
public class DocumentWorkflowStatusServiceClient extends DocumentWorkflowStatusServiceClientBase implements DocumentWorkflowStatusServiceI {

    public DocumentWorkflowStatusServiceClient(String url) throws MalformedURIException, RemoteException {
        this(url,null);
    }

    public DocumentWorkflowStatusServiceClient(String url, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(url,proxy);
    }

    public DocumentWorkflowStatusServiceClient(EndpointReferenceType epr) throws MalformedURIException, RemoteException {
           this(epr,null);
    }

    public DocumentWorkflowStatusServiceClient(EndpointReferenceType epr, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(epr,proxy);
    }

    public static void usage(){
        System.out.println(DocumentWorkflowStatusServiceClient.class.getName() + " -url <service url>");
    }

    public static void main(String [] args){
        System.out.println("Running the Grid Service Client");
        try{
        if(!(args.length < 2)){
            if(args[0].equals("-url")){
              DocumentWorkflowStatusServiceClient client = new DocumentWorkflowStatusServiceClient(args[1]);
              // place client calls here if you want to use this main as a
              // test....
              getTest(client);
              getByStudyProtocolTest(client);
              getCurrentByStudyProtocolTest(client);
            } else {
                usage();
                System.exit(1);
            }
        } else {
            usage();
            System.exit(1);
        }
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    private static void getTest(DocumentWorkflowStatusServiceClient client) throws RemoteException {
        Id id = new Id();
        id.setExtension("27427");
        DocumentWorkflowStatus result = client.get(id);
        System.out.println(ToStringBuilder.reflectionToString(result, ToStringStyle.MULTI_LINE_STYLE));
    }

    private static void getByStudyProtocolTest(DocumentWorkflowStatusServiceClient client) throws RemoteException {
        Id id = new Id();
        id.setExtension("27426");
        DocumentWorkflowStatus[] result = client.getByStudyProtocol(id);
        System.out.println(ToStringBuilder.reflectionToString(result, ToStringStyle.MULTI_LINE_STYLE));
    }

    private static void getCurrentByStudyProtocolTest(DocumentWorkflowStatusServiceClient client) throws RemoteException {
        Id id = new Id();
        id.setExtension("27426");
        DocumentWorkflowStatus result = client.getCurrentByStudyProtocol(id);
        System.out.println(ToStringBuilder.reflectionToString(result, ToStringStyle.MULTI_LINE_STYLE));
    }

  public gov.nih.nci.coppa.services.pa.DocumentWorkflowStatus getCurrentByStudyProtocol(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getCurrentByStudyProtocol");
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetCurrentByStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetCurrentByStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetCurrentByStudyProtocolRequestId idContainer = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetCurrentByStudyProtocolRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetCurrentByStudyProtocolResponse boxedResult = portType.getCurrentByStudyProtocol(params);
    return boxedResult.getDocumentWorkflowStatus();
    }
  }

  public gov.nih.nci.coppa.services.pa.DocumentWorkflowStatus[] getByStudyProtocol(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getByStudyProtocol");
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetByStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetByStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetByStudyProtocolRequestId idContainer = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetByStudyProtocolRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetByStudyProtocolResponse boxedResult = portType.getByStudyProtocol(params);
    return boxedResult.getDocumentWorkflowStatus();
    }
  }

  public void copy(gov.nih.nci.coppa.services.pa.Id fromStudyProtocolId,gov.nih.nci.coppa.services.pa.Id toStudyProtocolId) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"copy");
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CopyRequest params = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CopyRequest();
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CopyRequestFromStudyProtocolId fromStudyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CopyRequestFromStudyProtocolId();
    fromStudyProtocolIdContainer.setId(fromStudyProtocolId);
    params.setFromStudyProtocolId(fromStudyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CopyRequestToStudyProtocolId toStudyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CopyRequestToStudyProtocolId();
    toStudyProtocolIdContainer.setId(toStudyProtocolId);
    params.setToStudyProtocolId(toStudyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CopyResponse boxedResult = portType.copy(params);
    }
  }

  public gov.nih.nci.coppa.services.pa.DocumentWorkflowStatus get(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"get");
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetRequest params = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetRequest();
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetRequestId idContainer = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.GetResponse boxedResult = portType.get(params);
    return boxedResult.getDocumentWorkflowStatus();
    }
  }

  public gov.nih.nci.coppa.services.pa.DocumentWorkflowStatus create(gov.nih.nci.coppa.services.pa.DocumentWorkflowStatus documentWorkflowStatus) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"create");
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CreateRequest params = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CreateRequest();
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CreateRequestDocumentWorkflowStatus documentWorkflowStatusContainer = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CreateRequestDocumentWorkflowStatus();
    documentWorkflowStatusContainer.setDocumentWorkflowStatus(documentWorkflowStatus);
    params.setDocumentWorkflowStatus(documentWorkflowStatusContainer);
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.CreateResponse boxedResult = portType.create(params);
    return boxedResult.getDocumentWorkflowStatus();
    }
  }

  public gov.nih.nci.coppa.services.pa.DocumentWorkflowStatus update(gov.nih.nci.coppa.services.pa.DocumentWorkflowStatus documentWorkflowStatus) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"update");
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.UpdateRequest params = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.UpdateRequest();
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.UpdateRequestDocumentWorkflowStatus documentWorkflowStatusContainer = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.UpdateRequestDocumentWorkflowStatus();
    documentWorkflowStatusContainer.setDocumentWorkflowStatus(documentWorkflowStatus);
    params.setDocumentWorkflowStatus(documentWorkflowStatusContainer);
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.UpdateResponse boxedResult = portType.update(params);
    return boxedResult.getDocumentWorkflowStatus();
    }
  }

  public void delete(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"delete");
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.DeleteRequest params = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.DeleteRequest();
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.DeleteRequestId idContainer = new gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.DeleteRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.documentworkflowstatusservice.stubs.DeleteResponse boxedResult = portType.delete(params);
    }
  }

}
