package gov.nih.nci.coppa.services.pa.studyprotocolservice.client;

import gov.nih.nci.coppa.common.LimitOffset;
import gov.nih.nci.coppa.services.pa.Id;
import gov.nih.nci.coppa.services.pa.InterventionalStudyProtocol;
import gov.nih.nci.coppa.services.pa.StudyProtocol;
import gov.nih.nci.coppa.services.pa.studyprotocolservice.common.StudyProtocolServiceI;
import gov.nih.nci.pa.iso.util.IiConverter;

import java.rmi.RemoteException;

import org.apache.axis.client.Stub;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI.MalformedURIException;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.globus.gsi.GlobusCredential;

/**
 * This class is autogenerated, DO NOT EDIT GENERATED GRID SERVICE ACCESS METHODS.
 *
 * This client is generated automatically by Introduce to provide a clean unwrapped API to the
 * service.
 *
 * On construction the class instance will contact the remote service and retrieve it's security
 * metadata description which it will use to configure the Stub specifically for each method call.
 *
 * @created by Introduce Toolkit version 1.3
 */
public class StudyProtocolServiceClient extends StudyProtocolServiceClientBase implements StudyProtocolServiceI {

    public StudyProtocolServiceClient(String url) throws MalformedURIException, RemoteException {
        this(url,null);
    }

    public StudyProtocolServiceClient(String url, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(url,proxy);
    }

    public StudyProtocolServiceClient(EndpointReferenceType epr) throws MalformedURIException, RemoteException {
           this(epr,null);
    }

    public StudyProtocolServiceClient(EndpointReferenceType epr, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(epr,proxy);
    }

    public static void usage(){
        System.out.println(StudyProtocolServiceClient.class.getName() + " -url <service url>");
    }

    public static void main(String [] args){
        System.out.println("Running the Grid Service Client");
        try{
        if(!(args.length < 2)){
            if(args[0].equals("-url")){
              StudyProtocolServiceClient client = new StudyProtocolServiceClient(args[1]);

              System.out.println("Getting study protocol");
              getStudyProtocol(client);

              System.out.println("Getting interventional study protocol");
              getInterventionalStudyProtocol(client);

              System.out.println("searching for study protocols");
              search(client);

            } else {
                usage();
                System.exit(1);
            }
        } else {
            usage();
            System.exit(1);
        }
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    private static void getStudyProtocol(StudyProtocolServiceClient client) throws RemoteException {
        Id id = new Id();
        id.setRoot(IiConverter.STUDY_PROTOCOL_ROOT);
        id.setIdentifierName(IiConverter.STUDY_PROTOCOL_IDENTIFIER_NAME);
        id.setExtension("27453");
        StudyProtocol result = client.getStudyProtocol(id);
        System.out.println(ToStringBuilder.reflectionToString(result, ToStringStyle.MULTI_LINE_STYLE));
    }

    private static void getInterventionalStudyProtocol(StudyProtocolServiceClient client) throws RemoteException {
        Id id = new Id();
        id.setRoot(IiConverter.STUDY_PROTOCOL_ROOT);
        id.setIdentifierName(IiConverter.STUDY_PROTOCOL_IDENTIFIER_NAME);
        id.setExtension("27453");
        InterventionalStudyProtocol result = client.getInterventionalStudyProtocol(id);
        System.out.println(ToStringBuilder.reflectionToString(result, ToStringStyle.MULTI_LINE_STYLE));
    }

    private static void search(StudyProtocolServiceClient client) throws RemoteException {
        StudyProtocol sp = new StudyProtocol();

        LimitOffset limit = new LimitOffset();
        limit.setLimit(10);
        limit.setOffset(0);
        StudyProtocol[] results = client.search(sp, limit);
        System.out.println("search found " + results.length + " study relationship objects based on source protocol");
        for (int i = 0; i < results.length; i++) {
            System.out.println(ToStringBuilder.reflectionToString(results[i], ToStringStyle.MULTI_LINE_STYLE));
        }
    }

  public gov.nih.nci.coppa.services.pa.StudyProtocol getStudyProtocol(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getStudyProtocol");
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.GetStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.GetStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.GetStudyProtocolRequestId idContainer = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.GetStudyProtocolRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.GetStudyProtocolResponse boxedResult = portType.getStudyProtocol(params);
    return boxedResult.getStudyProtocol();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudyProtocol updateStudyProtocol(gov.nih.nci.coppa.services.pa.StudyProtocol studyProtocol) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"updateStudyProtocol");
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.UpdateStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.UpdateStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.UpdateStudyProtocolRequestStudyProtocol studyProtocolContainer = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.UpdateStudyProtocolRequestStudyProtocol();
    studyProtocolContainer.setStudyProtocol(studyProtocol);
    params.setStudyProtocol(studyProtocolContainer);
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.UpdateStudyProtocolResponse boxedResult = portType.updateStudyProtocol(params);
    return boxedResult.getStudyProtocol();
    }
  }

  public gov.nih.nci.coppa.services.pa.InterventionalStudyProtocol getInterventionalStudyProtocol(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getInterventionalStudyProtocol");
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.GetInterventionalStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.GetInterventionalStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.GetInterventionalStudyProtocolRequestId idContainer = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.GetInterventionalStudyProtocolRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.GetInterventionalStudyProtocolResponse boxedResult = portType.getInterventionalStudyProtocol(params);
    return boxedResult.getInterventionalStudyProtocol();
    }
  }

  public gov.nih.nci.coppa.services.pa.InterventionalStudyProtocol updateInterventionalStudyProtocol(gov.nih.nci.coppa.services.pa.InterventionalStudyProtocol interventionalStudyProtocol) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"updateInterventionalStudyProtocol");
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.UpdateInterventionalStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.UpdateInterventionalStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.UpdateInterventionalStudyProtocolRequestInterventionalStudyProtocol interventionalStudyProtocolContainer = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.UpdateInterventionalStudyProtocolRequestInterventionalStudyProtocol();
    interventionalStudyProtocolContainer.setInterventionalStudyProtocol(interventionalStudyProtocol);
    params.setInterventionalStudyProtocol(interventionalStudyProtocolContainer);
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.UpdateInterventionalStudyProtocolResponse boxedResult = portType.updateInterventionalStudyProtocol(params);
    return boxedResult.getInterventionalStudyProtocol();
    }
  }

  public gov.nih.nci.coppa.services.pa.Id createInterventionalStudyProtocol(gov.nih.nci.coppa.services.pa.InterventionalStudyProtocol interventionalStudyProtocol) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"createInterventionalStudyProtocol");
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.CreateInterventionalStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.CreateInterventionalStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.CreateInterventionalStudyProtocolRequestInterventionalStudyProtocol interventionalStudyProtocolContainer = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.CreateInterventionalStudyProtocolRequestInterventionalStudyProtocol();
    interventionalStudyProtocolContainer.setInterventionalStudyProtocol(interventionalStudyProtocol);
    params.setInterventionalStudyProtocol(interventionalStudyProtocolContainer);
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.CreateInterventionalStudyProtocolResponse boxedResult = portType.createInterventionalStudyProtocol(params);
    return boxedResult.getId();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudyProtocol[] search(gov.nih.nci.coppa.services.pa.StudyProtocol studyProtocol,gov.nih.nci.coppa.common.LimitOffset limitOffset) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault, gov.nih.nci.coppa.common.faults.TooManyResultsFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"search");
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.SearchRequest params = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.SearchRequest();
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.SearchRequestStudyProtocol studyProtocolContainer = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.SearchRequestStudyProtocol();
    studyProtocolContainer.setStudyProtocol(studyProtocol);
    params.setStudyProtocol(studyProtocolContainer);
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.SearchRequestLimitOffset limitOffsetContainer = new gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.SearchRequestLimitOffset();
    limitOffsetContainer.setLimitOffset(limitOffset);
    params.setLimitOffset(limitOffsetContainer);
    gov.nih.nci.coppa.services.pa.studyprotocolservice.stubs.SearchResponse boxedResult = portType.search(params);
    return boxedResult.getStudyProtocol();
    }
  }

}
