package gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.client;

import gov.nih.nci.coppa.services.pa.Id;
import gov.nih.nci.coppa.services.pa.StudyRegulatoryAuthority;
import gov.nih.nci.coppa.services.pa.faults.PAFault;
import gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.common.StudyRegulatoryAuthorityServiceI;
import gov.nih.nci.pa.iso.util.IiConverter;

import java.rmi.RemoteException;

import org.apache.axis.client.Stub;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI.MalformedURIException;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.globus.gsi.GlobusCredential;

/**
 * This class is autogenerated, DO NOT EDIT GENERATED GRID SERVICE ACCESS METHODS.
 *
 * This client is generated automatically by Introduce to provide a clean unwrapped API to the
 * service.
 *
 * On construction the class instance will contact the remote service and retrieve it's security
 * metadata description which it will use to configure the Stub specifically for each method call.
 *
 * @created by Introduce Toolkit version 1.3
 */
public class StudyRegulatoryAuthorityServiceClient extends StudyRegulatoryAuthorityServiceClientBase implements StudyRegulatoryAuthorityServiceI {

    public StudyRegulatoryAuthorityServiceClient(String url) throws MalformedURIException, RemoteException {
        this(url,null);
    }

    public StudyRegulatoryAuthorityServiceClient(String url, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(url,proxy);
    }

    public StudyRegulatoryAuthorityServiceClient(EndpointReferenceType epr) throws MalformedURIException, RemoteException {
           this(epr,null);
    }

    public StudyRegulatoryAuthorityServiceClient(EndpointReferenceType epr, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(epr,proxy);
    }

    public static void usage(){
        System.out.println(StudyRegulatoryAuthorityServiceClient.class.getName() + " -url <service url>");
    }

    public static void main(String [] args){
        System.out.println("Running the Grid Service Client");
        try{
        if(!(args.length < 2)){
            if(args[0].equals("-url")){
              StudyRegulatoryAuthorityServiceClient client = new StudyRegulatoryAuthorityServiceClient(args[1]);

              getByStudyProtocol(client);
              getCurrentByStudyProtocol(client);
              getById(client);
            } else {
                usage();
                System.exit(1);
            }
        } else {
            usage();
            System.exit(1);
        }
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    private static void getByStudyProtocol(StudyRegulatoryAuthorityServiceClient client) throws RemoteException, PAFault {
        System.out.println("Getting StudyRegulatoryAuthority by study protocol");
        Id id = new Id();
        id.setRoot(IiConverter.STUDY_PROTOCOL_ROOT);
        id.setIdentifierName(IiConverter.STUDY_PROTOCOL_IDENTIFIER_NAME);
        id.setExtension("27426");
        StudyRegulatoryAuthority[] results = client.getByStudyProtocol(id);
        printResults(results);
    }

    private static void getCurrentByStudyProtocol(StudyRegulatoryAuthorityServiceClient client) throws RemoteException, PAFault {
        System.out.println("Getting Current StudyRegulatoryAuthority by study protocol");
        Id id = new Id();
        id.setRoot(IiConverter.STUDY_PROTOCOL_ROOT);
        id.setIdentifierName(IiConverter.STUDY_PROTOCOL_IDENTIFIER_NAME);
        id.setExtension("27426");
        StudyRegulatoryAuthority results = client.getCurrentByStudyProtocol(id);
        printResults(results);
    }

    private static void getById(StudyRegulatoryAuthorityServiceClient client) throws RemoteException, PAFault {
        System.out.println("Getting StudyRegulatoryAuthority by ID");
        Id id = new Id();
        id.setExtension("27473");
        StudyRegulatoryAuthority results = client.get(id);
        printResults(results);
    }

    private static void printResults(StudyRegulatoryAuthority... results) {
        if (results != null) {
            System.out.println(results.length + " results found");
            for (int i = 0; i < results.length; i++) {
                System.out.println(ToStringBuilder.reflectionToString(results[i], ToStringStyle.MULTI_LINE_STYLE));
            }
        } else {
            System.out.println("No results found");
        }
    }

  public gov.nih.nci.coppa.services.pa.StudyRegulatoryAuthority[] getByStudyProtocol(gov.nih.nci.coppa.services.pa.Id studyProtocolId) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getByStudyProtocol");
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetByStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetByStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetByStudyProtocolRequestStudyProtocolId studyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetByStudyProtocolRequestStudyProtocolId();
    studyProtocolIdContainer.setId(studyProtocolId);
    params.setStudyProtocolId(studyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetByStudyProtocolResponse boxedResult = portType.getByStudyProtocol(params);
    return boxedResult.getStudyRegulatoryAuthority();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudyRegulatoryAuthority create(gov.nih.nci.coppa.services.pa.StudyRegulatoryAuthority studyRegulatoryAuthority) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"create");
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CreateRequest params = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CreateRequest();
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CreateRequestStudyRegulatoryAuthority studyRegulatoryAuthorityContainer = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CreateRequestStudyRegulatoryAuthority();
    studyRegulatoryAuthorityContainer.setStudyRegulatoryAuthority(studyRegulatoryAuthority);
    params.setStudyRegulatoryAuthority(studyRegulatoryAuthorityContainer);
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CreateResponse boxedResult = portType.create(params);
    return boxedResult.getStudyRegulatoryAuthority();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudyRegulatoryAuthority update(gov.nih.nci.coppa.services.pa.StudyRegulatoryAuthority studyRegulatoryAuthority) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"update");
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.UpdateRequest params = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.UpdateRequest();
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.UpdateRequestStudyRegulatoryAuthority studyRegulatoryAuthorityContainer = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.UpdateRequestStudyRegulatoryAuthority();
    studyRegulatoryAuthorityContainer.setStudyRegulatoryAuthority(studyRegulatoryAuthority);
    params.setStudyRegulatoryAuthority(studyRegulatoryAuthorityContainer);
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.UpdateResponse boxedResult = portType.update(params);
    return boxedResult.getStudyRegulatoryAuthority();
    }
  }

  public void copy(gov.nih.nci.coppa.services.pa.Id fromStudyProtocolId,gov.nih.nci.coppa.services.pa.Id toStudyProtocolId) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"copy");
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CopyRequest params = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CopyRequest();
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CopyRequestFromStudyProtocolId fromStudyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CopyRequestFromStudyProtocolId();
    fromStudyProtocolIdContainer.setId(fromStudyProtocolId);
    params.setFromStudyProtocolId(fromStudyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CopyRequestToStudyProtocolId toStudyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CopyRequestToStudyProtocolId();
    toStudyProtocolIdContainer.setId(toStudyProtocolId);
    params.setToStudyProtocolId(toStudyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.CopyResponse boxedResult = portType.copy(params);
    }
  }

  public gov.nih.nci.coppa.services.pa.StudyRegulatoryAuthority getCurrentByStudyProtocol(gov.nih.nci.coppa.services.pa.Id studyProtocolId) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getCurrentByStudyProtocol");
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetCurrentByStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetCurrentByStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetCurrentByStudyProtocolRequestStudyProtocolId studyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetCurrentByStudyProtocolRequestStudyProtocolId();
    studyProtocolIdContainer.setId(studyProtocolId);
    params.setStudyProtocolId(studyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetCurrentByStudyProtocolResponse boxedResult = portType.getCurrentByStudyProtocol(params);
    return boxedResult.getStudyRegulatoryAuthority();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudyRegulatoryAuthority get(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"get");
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetRequest params = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetRequest();
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetRequestId idContainer = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.GetResponse boxedResult = portType.get(params);
    return boxedResult.getStudyRegulatoryAuthority();
    }
  }

  public void delete(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"delete");
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.DeleteRequest params = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.DeleteRequest();
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.DeleteRequestId idContainer = new gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.DeleteRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.studyregulatoryauthorityservice.stubs.DeleteResponse boxedResult = portType.delete(params);
    }
  }

}
