package gov.nih.nci.coppa.services.pa.studysitecontactservice.client;

import gov.nih.nci.coppa.services.pa.Id;
import gov.nih.nci.coppa.services.pa.StudySiteContact;
import gov.nih.nci.coppa.services.pa.studysitecontactservice.common.StudySiteContactServiceI;
import gov.nih.nci.pa.iso.util.IiConverter;

import java.rmi.RemoteException;

import org.apache.axis.client.Stub;
import org.apache.axis.message.addressing.EndpointReferenceType;
import org.apache.axis.types.URI.MalformedURIException;
import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;
import org.globus.gsi.GlobusCredential;

/**
 * This class is autogenerated, DO NOT EDIT GENERATED GRID SERVICE ACCESS METHODS.
 *
 * This client is generated automatically by Introduce to provide a clean unwrapped API to the
 * service.
 *
 * On construction the class instance will contact the remote service and retrieve it's security
 * metadata description which it will use to configure the Stub specifically for each method call.
 *
 * @created by Introduce Toolkit version 1.3
 */
public class StudySiteContactServiceClient extends StudySiteContactServiceClientBase implements StudySiteContactServiceI {

    public StudySiteContactServiceClient(String url) throws MalformedURIException, RemoteException {
        this(url,null);
    }

    public StudySiteContactServiceClient(String url, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(url,proxy);
    }

    public StudySiteContactServiceClient(EndpointReferenceType epr) throws MalformedURIException, RemoteException {
           this(epr,null);
    }

    public StudySiteContactServiceClient(EndpointReferenceType epr, GlobusCredential proxy) throws MalformedURIException, RemoteException {
           super(epr,proxy);
    }

    public static void usage(){
        System.out.println(StudySiteContactServiceClient.class.getName() + " -url <service url>");
    }

    public static void main(String [] args){
        System.out.println("Running the Grid Service Client");
        try{
        if(!(args.length < 2)){
            if(args[0].equals("-url")){
              StudySiteContactServiceClient client = new StudySiteContactServiceClient(args[1]);
              // place client calls here if you want to use this main as a
              // test....
              getByStudyProtocol(client);
              getById(client);
            } else {
                usage();
                System.exit(1);
            }
        } else {
            usage();
            System.exit(1);
        }
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    private static void getByStudyProtocol(StudySiteContactServiceClient client) throws RemoteException {
        Id id = new Id();
        id.setRoot(IiConverter.STUDY_PROTOCOL_ROOT);
        id.setIdentifierName(IiConverter.STUDY_PROTOCOL_IDENTIFIER_NAME);
        id.setExtension("27426");
        StudySiteContact[] studySiteContacts = client.getByStudyProtocol(id);
        if (studySiteContacts != null) {
            System.out.println(studySiteContacts.length + " results found");
            for (int i = 0; i < studySiteContacts.length; i++) {
                System.out.println(ToStringBuilder.reflectionToString(studySiteContacts[i], ToStringStyle.MULTI_LINE_STYLE));
            }
        } else {
            System.out.println("No results found");
        }
    }

    private static void getById(StudySiteContactServiceClient client) throws RemoteException {
        Id id = new Id();
       // id.setRoot(IiConverter.STUDY_PROTOCOL_ROOT);
       // id.setIdentifierName(IiConverter.STUDY_PROTOCOL_IDENTIFIER_NAME);
        id.setExtension("180426");
        StudySiteContact studySiteContact = client.get(id);
        if (studySiteContact == null) {
            System.out.println("could not find StudyParticipantContact");
        } else {
            System.out.println("StudyParticipantContact found.");
        }
    }

  public void copy(gov.nih.nci.coppa.services.pa.Id fromStudyProtocolId,gov.nih.nci.coppa.services.pa.Id toStudyProtocolId) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"copy");
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CopyRequest params = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CopyRequest();
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CopyRequestFromStudyProtocolId fromStudyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CopyRequestFromStudyProtocolId();
    fromStudyProtocolIdContainer.setId(fromStudyProtocolId);
    params.setFromStudyProtocolId(fromStudyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CopyRequestToStudyProtocolId toStudyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CopyRequestToStudyProtocolId();
    toStudyProtocolIdContainer.setId(toStudyProtocolId);
    params.setToStudyProtocolId(toStudyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CopyResponse boxedResult = portType.copy(params);
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySiteContact create(gov.nih.nci.coppa.services.pa.StudySiteContact studySiteContact) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"create");
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CreateRequest params = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CreateRequest();
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CreateRequestStudySiteContact studySiteContactContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CreateRequestStudySiteContact();
    studySiteContactContainer.setStudySiteContact(studySiteContact);
    params.setStudySiteContact(studySiteContactContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.CreateResponse boxedResult = portType.create(params);
    return boxedResult.getStudySiteContact();
    }
  }

  public void delete(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"delete");
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.DeleteRequest params = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.DeleteRequest();
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.DeleteRequestId idContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.DeleteRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.DeleteResponse boxedResult = portType.delete(params);
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySiteContact get(gov.nih.nci.coppa.services.pa.Id id) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"get");
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetRequest params = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetRequest();
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetRequestId idContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetRequestId();
    idContainer.setId(id);
    params.setId(idContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetResponse boxedResult = portType.get(params);
    return boxedResult.getStudySiteContact();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySiteContact[] getByStudySite(gov.nih.nci.coppa.services.pa.Id studySiteId) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getByStudySite");
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudySiteRequest params = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudySiteRequest();
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudySiteRequestStudySiteId studySiteIdContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudySiteRequestStudySiteId();
    studySiteIdContainer.setId(studySiteId);
    params.setStudySiteId(studySiteIdContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudySiteResponse boxedResult = portType.getByStudySite(params);
    return boxedResult.getStudySiteContact();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySiteContact[] getByStudyProtocol(gov.nih.nci.coppa.services.pa.Id studyProtocolId) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getByStudyProtocol");
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolRequest params = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolRequest();
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolRequestStudyProtocolId studyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolRequestStudyProtocolId();
    studyProtocolIdContainer.setId(studyProtocolId);
    params.setStudyProtocolId(studyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolResponse boxedResult = portType.getByStudyProtocol(params);
    return boxedResult.getStudySiteContact();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySiteContact[] getByStudyProtocolAndRole(gov.nih.nci.coppa.services.pa.Id studyProtocolId,gov.nih.nci.coppa.services.pa.StudySiteContact studySiteContact) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getByStudyProtocolAndRole");
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRoleRequest params = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRoleRequest();
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRoleRequestStudyProtocolId studyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRoleRequestStudyProtocolId();
    studyProtocolIdContainer.setId(studyProtocolId);
    params.setStudyProtocolId(studyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRoleRequestStudySiteContact studySiteContactContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRoleRequestStudySiteContact();
    studySiteContactContainer.setStudySiteContact(studySiteContact);
    params.setStudySiteContact(studySiteContactContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRoleResponse boxedResult = portType.getByStudyProtocolAndRole(params);
    return boxedResult.getStudySiteContact();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySiteContact[] getByStudyProtocolAndRoles(gov.nih.nci.coppa.services.pa.Id studyProtocolId,gov.nih.nci.coppa.services.pa.StudySiteContact[] studySiteContact) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"getByStudyProtocolAndRoles");
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRolesRequest params = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRolesRequest();
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRolesRequestStudyProtocolId studyProtocolIdContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRolesRequestStudyProtocolId();
    studyProtocolIdContainer.setId(studyProtocolId);
    params.setStudyProtocolId(studyProtocolIdContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRolesRequestStudySiteContact studySiteContactContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRolesRequestStudySiteContact();
    studySiteContactContainer.setStudySiteContact(studySiteContact);
    params.setStudySiteContact(studySiteContactContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.GetByStudyProtocolAndRolesResponse boxedResult = portType.getByStudyProtocolAndRoles(params);
    return boxedResult.getStudySiteContact();
    }
  }

  public gov.nih.nci.coppa.services.pa.StudySiteContact update(gov.nih.nci.coppa.services.pa.StudySiteContact studySiteContact) throws RemoteException, gov.nih.nci.coppa.services.pa.faults.PAFault {
    synchronized(portTypeMutex){
      configureStubSecurity((Stub)portType,"update");
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.UpdateRequest params = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.UpdateRequest();
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.UpdateRequestStudySiteContact studySiteContactContainer = new gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.UpdateRequestStudySiteContact();
    studySiteContactContainer.setStudySiteContact(studySiteContact);
    params.setStudySiteContact(studySiteContactContainer);
    gov.nih.nci.coppa.services.pa.studysitecontactservice.stubs.UpdateResponse boxedResult = portType.update(params);
    return boxedResult.getStudySiteContact();
    }
  }

}
